#pragma once

#include <atlimage.h>


class CEvImage : public CImage
{
private:
	//////////////////////////
	LPBYTE		m_pPxlPtr;
	LPBYTE*		m_pPxl2D;
	//////////////////////////

public:
	CEvImage(void);
	virtual ~CEvImage(void);
	void	Free();

public:
	void	CreateColorTable();
	BOOL	Create(LONG nWidth, LONG nHeight, WORD nDepth);

	BOOL	IsValid() const;
	LPBYTE	GetPxlPtr();
	LPBYTE*	GetPxl2D();
	LPBYTE	GetRowPtr(LONG row);

	BOOL	Draw(HDC hDC, int x, int y, int width, int height) const;

	BOOL	OpenFile(LPCTSTR lpszPathName);

private:
	void	AllocPxl2D();
};
