#include "stdafx.h"

//////////////////////////////
#include "ZMemDC.h"
//////////////////////////////

CZMemDC::CZMemDC(CDC* pDC, CRect rect) : CDC(), m_pBmpOld(NULL), m_pDC(pDC)
{
	ASSERT(m_pDC != NULL);

	m_bMemDC = !pDC->IsPrinting();
	if ( m_bMemDC )
	{
		CreateCompatibleDC(pDC);
		if ( rect == CRect(0,0,0,0) )
		{
			pDC->GetClipBox(&m_rect);
		}
		else
		{
			m_rect = rect;
		}
		
		m_bmp.CreateCompatibleBitmap(pDC, m_rect.Width(), m_rect.Height());
		m_pBmpOld = SelectObject(&m_bmp);
		SetWindowOrg(m_rect.left, m_rect.top);
	}
	else
	{
		m_bPrinting = pDC->m_bPrinting;
		m_hDC = pDC->m_hDC;
		m_hAttribDC = pDC->m_hAttribDC;
	}
}


CZMemDC::~CZMemDC()
{
	if ( m_bMemDC )
	{
		m_pDC->BitBlt( m_rect.left, m_rect.top, m_rect.Width(), m_rect.Height(),
				this, m_rect.left, m_rect.top, SRCCOPY );
		SelectObject(m_pBmpOld);
	}
	else
	{
		m_hDC = m_hAttribDC = NULL;
	}
}
//////////////////////////////