
// viewUsb3Doc.cpp : implementation of the CviewUsb3Doc class
//

#include "stdafx.h"
#include "viewUsb3.h"

#include "viewUsb3Doc.h"

#include "SourceDlg.h"
#include "viewUsb3View.h"

const unsigned int code_notify_capture = WM_USER + 101;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CviewUsb3Doc

IMPLEMENT_DYNCREATE(CviewUsb3Doc, CDocument)

BEGIN_MESSAGE_MAP(CviewUsb3Doc, CDocument)
END_MESSAGE_MAP()


// CviewUsb3Doc construction/destruction

CviewUsb3Doc::CviewUsb3Doc()
: m_pSourceDlg(NULL)
{
	// TODO: add one-time construction code here
}

CviewUsb3Doc::~CviewUsb3Doc()
{
	if(m_pSourceDlg)
	{
		m_pSourceDlg->DestroyWindow();

		delete m_pSourceDlg;
		m_pSourceDlg = NULL;
	}
}

BOOL CviewUsb3Doc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	if(m_pSourceDlg == NULL)
	{
		m_pSourceDlg = new CSourceDlg(this);
		if(m_pSourceDlg)
		{
			m_pSourceDlg->Create( IDD_DIALOG_SOURCE , CWnd::GetDesktopWindow());
			m_pSourceDlg->ShowWindow( SW_SHOW );
		}
	}

	return TRUE;
}




// CviewUsb3Doc serialization

void CviewUsb3Doc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}


// CviewUsb3Doc diagnostics

#ifdef _DEBUG
void CviewUsb3Doc::AssertValid() const
{
	CDocument::AssertValid();
}

void CviewUsb3Doc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

BOOL CviewUsb3Doc::OnOpenDocument(LPCTSTR lpszPathName)
{
	if (!__super::OnOpenDocument(lpszPathName))
		return FALSE;

	// TODO:  ⿡ Ưȭ ۼ ڵ带 ߰մϴ.
	m_Img.OpenFile(lpszPathName);
	UpdateAllViews(NULL, HINT_UPDATE_OPEN_IMAGE);

	return TRUE;
}

// ̹  غϴ ܰ
int CviewUsb3Doc::OnPrepare(int iFormat, int iWidth, int iHeight)
{
	m_Img.Create(iWidth, iHeight, 24);
	return 0;
}

//  Լ IFrameCapture ̽  ۾ 忡 ȣϴ ԼԴϴ.
int CviewUsb3Doc::OnCapture(PBYTE pBuffer, int iWidth, int iHeight)
{
	PBYTE *ppPxlPtr = m_Img.GetPxl2D();
	if(ppPxlPtr == NULL)
		return -1;

	//   Ʈ 
	ULONG lWLength = iWidth;
	// 4Ʈ   Padding byte ߰
	while(lWLength % 4 != 0)
		lWLength++;

	int line_size = lWLength * 3;

	for(int i = 0; i < iHeight; i++)
	{
		RtlCopyMemory(ppPxlPtr[i], pBuffer + (line_size * i), iWidth * 3);
	}

	// UI Thread ó  ֵ WM_NOTIFY ޽ ̿Ͽ DOC ޽ Ѵ.
    // TRACE( _T("CviewUsb3Doc::OnCapture\n") ) ;
    HWND hMain = AfxGetApp()->m_pMainWnd->GetSafeHwnd();
	NMHDR *hdr = new NMHDR;
	if(hdr == NULL) return -1;
	hdr->hwndFrom = hMain;
	hdr->code = code_notify_capture;
	hdr->idFrom = 0;
    ::PostMessage( hMain, WM_NOTIFY, 0, (LPARAM)hdr ) ;
	return 0;
}

BOOL CviewUsb3Doc::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.
	if ( HIWORD(nCode) == WM_NOTIFY )
	// verify that this is a WM_NOTIFY message
	{
		AFX_NOTIFY * notify = reinterpret_cast<AFX_NOTIFY*>(pExtra) ;
		if ( notify->pNMHDR->code == code_notify_capture )
			// verify that this is our notification
		{
			//TRACE("CviewUsb3Doc::OnCmdMsg: %d\n", notify->pNMHDR->code);
			NMHDR *hdr = notify->pNMHDR;
			delete hdr;
			UpdateAllViews(NULL);
		}
	}
	return __super::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}
