
// viewUsb3.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "afxwinappex.h"
#include "viewUsb3.h"
#include "MainFrm.h"

#include "viewUsb3Doc.h"
#include "viewUsb3View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CviewUsb3App

BEGIN_MESSAGE_MAP(CviewUsb3App, CWinAppEx)
	ON_COMMAND(ID_APP_ABOUT, &CviewUsb3App::OnAppAbout)
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, &CWinAppEx::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, &CWinAppEx::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, &CWinAppEx::OnFilePrintSetup)
END_MESSAGE_MAP()


// CviewUsb3App construction

CviewUsb3App::CviewUsb3App()
{

	m_bHiColorIcons = TRUE;

	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

// The one and only CviewUsb3App object

CviewUsb3App theApp;


// CviewUsb3App initialization

BOOL CviewUsb3App::InitInstance()
{
	// InitCommonControlsEx() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// Set this to include all the common control classes you want to use
	// in your application.
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	CWinAppEx::InitInstance();

	// Initialize OLE libraries
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}
	AfxEnableControlContainer();
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	// of your final executable, you should remove from the following
	// the specific initialization routines you do not need
	// Change the registry key under which our settings are stored
	// TODO: You should modify this string to be something appropriate
	// such as the name of your company or organization
	SetRegistryKey(_T("viewUsb3"));
	LoadStdProfileSettings(0);  // Load standard INI file options (including MRU)

	InitContextMenuManager();

	InitKeyboardManager();

	InitTooltipManager();
	CMFCToolTipInfo ttParams;
	ttParams.m_bVislManagerTheme = TRUE;
	theApp.GetTooltipManager()->SetTooltipParams(AFX_TOOLTIP_TYPE_ALL,
		RUNTIME_CLASS(CMFCToolTipCtrl), &ttParams);

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views
	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CviewUsb3Doc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CviewUsb3View));
	if (!pDocTemplate)
		return FALSE;
	AddDocTemplate(pDocTemplate);


	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);


	// Dispatch commands specified on the command line.  Will return FALSE if
	// app was launched with /RegServer, /Register, /Unregserver or /Unregister.
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The one and only window has been initialized, so show and update it
	m_pMainWnd->ShowWindow(SW_SHOW);
	m_pMainWnd->UpdateWindow();
	// call DragAcceptFiles only if there's a suffix
	//  In an SDI app, this should occur after ProcessShellCommand
	CString strVersion, strCaption = "EnvyLogic USB3 Frame Grabber Sample Program v";
	GetAppVersion(strVersion);
	strCaption += strVersion;
	m_pMainWnd->SetWindowText(strCaption);

	return TRUE;
}



// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

// App command to run the dialog
void CviewUsb3App::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

// CviewUsb3App customization load/save methods

void CviewUsb3App::PreLoadState()
{
	BOOL bNameValid;
	CString strName;
	bNameValid = strName.LoadString(IDS_EDIT_MENU);
	ASSERT(bNameValid);
	GetContextMenuManager()->AddMenu(strName, IDR_POPUP_EDIT);
}

void CviewUsb3App::LoadCustomState()
{
}

void CviewUsb3App::SaveCustomState()
{
}

// CviewUsb3App message handlers




int CviewUsb3App::ExitInstance()
{
	// TODO: ⿡ Ưȭ ڵ带 ߰ /Ǵ ⺻ Ŭ ȣմϴ.

	return CWinAppEx::ExitInstance();
}

void CviewUsb3App::GetAppVersion(CString& refString)
{
	//   α׷ θ  ̴.
	char temp_path[MAX_PATH];

	//   α׷ θ ´.
	GetModuleFileName(AfxGetInstanceHandle(), temp_path, sizeof(temp_path));

    //      ڵ鰪 ϴ ̴.
    DWORD h_version_handle;

    //  ׸ ڰ ߰/ Ҽ ֱ   ũⰡ ƴϴ.
    //   α׷   ũ⸦   ũ⿡ ´ ޸𸮸 Ҵϰ ۾ؾѴ.
    DWORD version_info_size = GetFileVersionInfoSize(temp_path, &h_version_handle);

    //  ϱ  ý ޸𸮸 Ѵ. ( ڵ   )
    HANDLE h_memory = GlobalAlloc(GMEM_MOVEABLE, version_info_size); 

    // ڵ  ޸𸮸 ϱ ؼ ش ڵ鿡 Ҽ ִ ּҸ ´.
    LPVOID p_info_memory = GlobalLock(h_memory);

    //  α׷   ´.
    GetFileVersionInfo(temp_path, h_version_handle, version_info_size, p_info_memory);

    //   Ե  ׸  ġ  ̴.  Ϳ ޵ ּҴ
    // p_info_memory   ġ̱  ϸ ȵ˴ϴ.
    // ( p_info_memory  ϴ   Դϴ. )
    char *p_data = NULL;

    //    ũ⸦  ̴.
    UINT data_size = 0;

    //  Ե FileVersion   Ѵ.
    if(VerQueryValue(p_info_memory, "\\StringFileInfo\\040904e4\\FileVersion", (void **)&p_data, &data_size)){ 
		refString = p_data;
    }

    //   ϱ  ߴ ޸𸮸 Ѵ.
    GlobalUnlock(h_memory); 
    GlobalFree(h_memory);
}

