
// viewUsb3Doc.h : interface of the CviewUsb3Doc class
//
#pragma once

#include "IFrameCapture.h"
#include "EvImage.h"


// OnUpdate lHint  
enum {
	HINT_UPDATE_OPEN_IMAGE,
	HINT_UPDATE_FIT_WINDOW,
	HINT_UPDATE_ZOOM_IMAGE
};

class CSourceDlg;
class CviewUsb3View;

class CviewUsb3Doc : 
	public CDocument,
	public IFrameCapture
{
protected: // create from serialization only
	CviewUsb3Doc();
	DECLARE_DYNCREATE(CviewUsb3Doc)

// Attributes
public:
	CSourceDlg	*m_pSourceDlg;
	CEvImage	m_Img;

// Operations
public:
	//void Draw(CDC* pDC, CviewUsb3View *pView);
	void SetView(CviewUsb3View *pView);

// Overrides
public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);

	// ̹  غϴ ܰ
	virtual int OnPrepare(int iFormat, int iWidth, int iHeight);
	// IFrameCapture ̽ 
	virtual int OnCapture(PBYTE pBuffer, int iWidth, int iHeight);


// Implementation
public:
	virtual ~CviewUsb3Doc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
};


